import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Calendar;
import java.util.Vector;

import javax.microedition.io.Connector;

import com.nttdocomo.system.ImageStore;
import com.nttdocomo.ui.Canvas;
import com.nttdocomo.ui.TextBox;
import com.nttdocomo.ui.Dialog;
import com.nttdocomo.ui.Display;
import com.nttdocomo.ui.Font;
import com.nttdocomo.ui.Frame;
import com.nttdocomo.ui.Graphics;
import com.nttdocomo.ui.IApplication;
import com.nttdocomo.ui.Image;
import com.nttdocomo.ui.MediaImage;
import com.nttdocomo.ui.MediaManager;
import com.nttdocomo.ui.ImageEncoder;
import com.nttdocomo.ui.EncodedImage;

public final class GBACanvas extends Canvas {

	private static final String VERSION_STR
		=	"     YGBAPlus"     + "\n"
								+ "\n" +
			" is made based on" + "\n" +
			"       YGBA"       + "\n" +
			"     by Mr.407"  	+ "\n"
								+ "\n" +
			"Thanks All Author!"+ "\n"
	;

	private static final String SOFTKEY_ROOT_STR   = "MENU";
	private static final String SOFTKEY_ROM_STR    = "̕ҏW";
	private static final String SOFTKEY_KEYSET_STR = "ݒر";
	private static final String SOFTKEY_SAVE_STR   = "ް폜";
	private static final String SOFTKEY_PAD_STR    = "PADݒ";
	private static final String SOFTKEY_RESET_STR  = "RESET";
	private static final String SOFTKEY_RET_STR    = " ߂ ";
	private static final String SOFTKEY_EXIT_STR   = " I ";

	/**
	 * ScratchPadpo[W.
	 * ꂪƂɏNScratchPadf[^ړB
	 */
	private static final int VERSION = 300;

	// 萔
	private static final int MODE_GAME = 1;
	private static final int MODE_MENU_ROOT = 2;
	private static final int MODE_MENU_SAVE = 3;
	private static final int MODE_MENU_LOAD = 4;
	private static final int MODE_MENU_ROM = 5;
	private static final int MODE_MENU_EXPORT = 6;
	private static final int MODE_MENU_IMPORT = 7;
	private static final int MODE_MENU_SETTING = 8;
	private static final int MODE_MENU_KEYCON = 9;
	private static final int MODE_MENU_KEYCON_SET = 10;
	private static final int MODE_MENU_BUTTON_SET = 11;
	private static final int MODE_MENU_ROMFILE = 12;
	private static final int MODE_MENU_CONFIRM = 13;
	private static final int MODE_MENU_TOOLS = 14;
	/** Z[uf[^. */
	private static final int NUM_SAVE = 12;

	/** y[WSDROM. */
	private static final int NUM_SDROM = 12;
	
	/** őSDROM y[W. */
	private static final int MAX_SDROM_PAGE = 20;

	/** Z[uf[^P̃TCY. */
	private static final int SIZE_SAVE = 0x96800;

	/*
	 * ݒۑp̃TCY.
	 */
	private static final int SIZE_SP_OTHERS = 100;
	private static final int SIZE_SP_KEYS = 240;
	private static final int SIZE_SP_SAVES = 500;
	private static final int SIZE_SP_ADJUST = 120; //(NUM_SDROM * MAX_SDROM_PAGE) / 2
	private static final int SIZE_SP_RESERVE = 40;
	private static final int SIZE_SP_SETTING = 1000;

	/** Save1̖OB{Game. */
	private static final int SIZE_SAVE_NAME = 34;

	/** ROM̒ */
	private static final int SIZE_ROM_NAME = 30;

	/* Exportp1Block̃TCY */
	private static final int EXPORT_BLOCK_SIZE = 255;

	// j[e
	String[] MENU_ROOT =
		new String[] {
			"ROMI",
			"f[^[h",
			"f[^Z[u",
			"Zbg",
			"Sʐݒ",
			"L[ݒ",
			"pbh@\ݒ",
			"c[",
			"Ver.",};

	String[] MENU_KEYCON =
		new String[] {
			"A{^",
			"B{^",
			"SELECT{^",
			"START{^",
			"L[",
			"L[",
			"L[",
			"L[",
			"[h",
			"Z[u",
			"ڰѽ+1",
			"ڰѽ-1" };

	String[] ON_OFF_STR = new String[] { "OFF", "ON" };
	String[] FRAMES_STR = new String[] { "OFF", "LIMIT", "AUTO" };
	String[] FLIPMODE_STR = new String[] { "ʏ", "E90", "180", "90" };
	String[] SOFTKEY_STR = 
		new String[] {
			"pbhݒ",
			"Zbg",
			"Cӷݒ" };
	String[] SOFTKEY_BGCOLOR_STR = new String[] { "BLUE", "GRAY", "BLACK", "BLUE+", "GRAY+", "BLACK+" };

	// CX^Xϐ
	private GBACore core;

	public static int[] fb = new int[240*160];
	private int joypad, joypadBit, joypadBit2, joypadMic;
	private final int padTbl[][] = new int[][] {
								  { 0, 1, 2, 3, 4, 5, 6, 7},
								  { 0, 1, 2, 3, 6, 7, 5, 4},
								  { 0, 1, 2, 3, 5, 4, 7, 6},
								  { 0, 1, 2, 3, 7, 6, 4, 5}};
	private int frame_count, last_frame;
	private int skippedFrameCount;
	private long lastTime_, startTime_;
	private String messageStr = "";

	/////////////////////////////////
	// ݒ荀
	/////////////////////////////////
	// fps
	int fps_ = 0;
	// FrameSkip
	private int frameSkip_ = 5;
	// fps\邩ǂB
	private boolean fpsOff_;
	// NɑOROMǂݍނB
	private int startAndLoad_ = 0;
	// A{^A
	private int aRen_ = 0;
	// B{^A
	private int bRen_ = 0;
	// A{^z[h
	private int aHold_ = 0;
	// B{^z[h
	private int bHold_ = 0;
	// 2PRg[
	private int con2p_ = 0;
	// A˃JE^
	private int rcount_ = 0;
	// j[̓
	private boolean alpha_;
	// x(60FPS)
	private int sleep_ = 0;
	// 90](0:ʏA1:EA2:180A3:)
	private int flipMode_ = 0;
	// E\tgL[̋@\
	private int rSoftkey_ = 0;
	// j[wiF
	private int menuBGcolor_ = 0;
	// mFbZ[W
	private int confirmMsg_ = 0;
	// NtO
	private boolean firstExec_ = false;
	// SDROMt@CXg
	private String[] sdRomnm_ = new String[NUM_SDROM];
	// SDROMAWXgXg
	private int[] sdRomadj_ = new int[NUM_SDROM * MAX_SDROM_PAGE];
	// OSDROMԍ
	private int sdNo_ = 0;
	// SRAMZ[ut@C
	private String saveFile_ = null;
	// SDt@Cy[W
	private int sdPage_ = 0;
	// Save{Game
	private String[] saveStr_ = new String[NUM_SAVE];
	// ݒޔ
	private int svframeSkip_ = 0;
	// E\tgL[}XN
	private int skeyMask_ = 0;
	//ǂݍł邩ǂ
	private boolean romload;
	
	/////////////////////////////////
	// ̑CX^X
	/////////////////////////////////
	// N̓j[\
	private int mode_ = MODE_MENU_ROM;
	// JgROM
	private String saveRomName = "";
	// SDROMy[Wԍ
	private int page_ = 1;
	// rootj[Iԍ
	private int selectMenuNo_ = 0;
	// SubMenu
	private int selectSubMenuNo_ = 0;
	private int svSubMenuLoadNo = 0;
	private int svSubMenuSaveNo = 0;
	private int svSubMenuSettingNo = 0;
	private int svSubMenuKeyConfNo = 0;
	private int svSubMenuPadNo = 0;
	private int svSubMenuToolNo = 0;
	private int svSubMenuImportNo = 0;
	private int svSubMenuExportNo = 0;

	// SubMenuXg
	String[] subMenu_ = new String[1];
	// L[ݒ
	String[] keyconStr_ = new String[MENU_KEYCON.length];
	int[][] keyConfig_ = new int[keyconStr_.length][];
	// pbh@\ptO
	private boolean padDisp_ = false;
	private boolean displayClear;


	private Image img;
	private Image allImg = null; //]pS̃C[W
	private Graphics allG = null;

	private byte[] GIF_HEADER = { 'G', // 0x47
		'I', // 0x49
		'F', // 0x46
		'8', // 0x38
		'9', // 0x39
		'a', // 0x61
		0x01,
			0x00,
			0x01,
			0x00,
			0x80 - 0x100,
			0x00,
			0x00,
			0xFF - 0x100,
			0xFF - 0x100,
			0xFF - 0x100,
			0x00,
			0x00,
			0x00,
			0x2C,
			0x00,
			0x00,
			0x00,
			0x00,
			0x01,
			0x00,
			0x01,
			0x00,
			0x00,
			0x02,
			0x02,
			0x44,
			0x01,
			0x00,
			0x21,
			0xFE - 0x100 };

	private final Font DEFAULT_FONT;
	private final int HEIGHT_LINE;
	private final int BASE_LINE;

	{
		DEFAULT_FONT = Font.getDefaultFont();
		// s = tHg + ̗] + ̗]
		HEIGHT_LINE = DEFAULT_FONT.getHeight() + 1 + 2 * 2;
		// x[X = ] + tHgAscent
		BASE_LINE = 3 + DEFAULT_FONT.getAscent();
	}

	GBACanvas() {
		setSoftLabel(Frame.SOFT_KEY_1, SOFTKEY_ROOT_STR);
		setBackground(Graphics.getColorOfName(Graphics.BLACK));
		allImg = Image.createImage(240, 240);
		allG = allImg.getGraphics();

		try {
			MediaImage mi = MediaManager.getImage("resource:///title.gif");
			mi.use();
			img = mi.getImage();
		} catch (IOException e) {}

		// XNb`pbhǍ
		readSP();
		readSPkeys();
		readSPsaves();
		readSPadjusts();
		// SDt@CPy[W쐬
		if (!firstExec_) {
			sdPage_ = 1;
			createSdfiles(1);
			createBiosfile();
			firstExec_ = true;
			writeSP();
		}
		setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_ROM_STR);
		page_ = sdNo_ / NUM_SDROM + 1;
		selectSubMenuNo_ = sdNo_ % NUM_SDROM;
		readSdromNameSP(page_);

		core = new GBACore(this);

		// OROMǂݍ
		if (startAndLoad_ == 1) {
			loadRom();
		}
	}

	private final void resetFrame() {
		frame_count = 0;
		last_frame = 0;
		skippedFrameCount = 0;
		lastTime_ = 0;
		startTime_ = 0;
	}

	public boolean startFrame() {
		frame_count++;
		if (sleep_  == 2) {
			double ftime,dtime;
			long ctime;
			if (frame_count % 61 == 0) {
				if (!fpsOff_) messageStr = (60 - skippedFrameCount) + "/60 frames.";
				skippedFrameCount = 0;
			}
			ctime = System.currentTimeMillis();
			ftime = startTime_ + 16.66666 * frame_count;
			dtime = ctime - ftime;
			if (dtime > 500 || dtime < -500) {
				startTime_ = System.currentTimeMillis();
				frame_count = 0;
				last_frame = 0;
			}
			if (ctime < ftime) {
				return true;
			} else {
				skippedFrameCount++;
				if(skippedFrameCount == 60)
					return true;
				else
					return false;
			}
		} else {
			return frame_count % frameSkip_ == 0;
		}
	}

	Graphics g = getGraphics();

	public void endFrame() {
		if (frame_count - last_frame >= 60) {
			long current = System.currentTimeMillis();
			fps_ = 60000 / (int) (current - lastTime_);
			last_frame += 60;
			lastTime_ = current;

			if (!fpsOff_ && sleep_ < 2) {
				messageStr = fps_ + "FPS FS=" + frameSkip_;
			}
		}

		paint(g);

		// x(60FPS)
		if (sleep_ == 1) {
			long tm = startTime_ + (long)(1667 * frameSkip_ / 100);
			do {
				startTime_ = System.currentTimeMillis();
			} while (tm > startTime_);
			long delay = (startTime_ - tm);
			if (delay > 0 && delay < 50) {
				startTime_ -= delay;
			}
		}
	}

	public final short readJoyPad() {
		int key, Input;

		key = getKeypadState();
		Input = 0x03FF;

		if ((key & (1 << Display.KEY_3))	 == 0x00008) Input &= ~0x0001; // A
		if ((key & (1 << Display.KEY_2))	 == 0x00004) Input &= ~0x0002; // B
		if ((key & (1 << Display.KEY_5))	 == 0x00020) Input &= ~0x0004; // Select
		if ((key & (1 << Display.KEY_6))	 == 0x00040) Input &= ~0x0008; // Start
		if ((key & (1 << Display.KEY_RIGHT)) == 0x40000) Input &= ~0x0010; // 
		if ((key & (1 << Display.KEY_LEFT))  == 0x10000) Input &= ~0x0020; // 
		if ((key & (1 << Display.KEY_UP))	== 0x20000) Input &= ~0x0040; // 
		if ((key & (1 << Display.KEY_DOWN))  == 0x80000) Input &= ~0x0080; // 
		if ((key & (1 << Display.KEY_9))	 == 0x00200) Input &= ~0x0100; // R
		if ((key & (1 << Display.KEY_8))	 == 0x00100) Input &= ~0x0200; // L

		return (short) Input;
	}

	public int readJoyPadBit() {
		// GAME[ĥ
		if (joypadBit == 0 && mode_ == MODE_GAME) {
			joypadBit2 = 0;
			int key = getKeypadState() & skeyMask_;
			//System.out.println("getKeypadState:" + key);
			// KeyConfigp
			int[] keyArray = new int[8];
			for (int i = 0; i < keyArray.length; i++) {
				// Ƃ肠dœo^ł̂5܂ŁB
				int[] condition = new int[5];
				for (int j = 0; j < keyConfig_[i].length; j++) {
					condition[j] = key >> keyConfig_[i][j];
				}
				keyArray[i] =
					((condition[0]
						| condition[1]
						| condition[2]
						| condition[3]
						| condition[4])
						& 1)
						<< padTbl[flipMode_][i];
			}

			// AˁAz[h
			rcount_++;
			if (aHold_ == 1) keyArray[0] ^= 0x01;
			if (aRen_ != 0 && keyArray[0] == 0x01 && (rcount_ & (1 << (aRen_ - 1))) == 0) keyArray[0] = 0;
			if (bHold_ == 1) keyArray[1] ^= 0x02;
			if (bRen_ != 0 && keyArray[1] == 0x02 && (rcount_ & (1 << (bRen_ - 1))) == 0) keyArray[1] = 0;

			joypad =
				keyArray[0]
					| keyArray[1]
					| keyArray[2]
					| keyArray[3]
					| keyArray[4]
					| keyArray[5]
					| keyArray[6]
					| keyArray[7];
		}

		//int n = (joypad >> joypadBit) & 1;
		//}CNrbgt
		int n = joypadMic;
		if (con2p_ != 2) n = (joypad >> joypadBit) & 1 | joypadMic;
		joypadBit = (joypadBit + 1) & 7;
		return n;
	}

	public void resetJoyPad() {
		joypadBit = 0;
	}

	public String getSaveFile(final int slot) {
		return "NO" + formatNumber(slot, 2) + ".SAV";
	}

	public String getSramSaveFile() {
		return saveFile_;
	}

	public void setMessage(final String s) {
		g.lock();
		g.setColor(Graphics.getColorOfName(Graphics.BLACK));
		g.fillRect(0, 224, 240, 16);
		g.setColor(Graphics.getColorOfName(Graphics.WHITE));
		g.drawString(s, 4, 224 + BASE_LINE);
		g.unlock(true);
	}

	public void processEvent(final int type, final int param) {
		if (type == Display.KEY_PRESSED_EVENT) {
			switch (mode_) {
				case MODE_GAME :
					switch (param) {
						case Display.KEY_SOFT1 :
							core.request(GBACore.REQUEST_SLEEP, 0);
							setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_EXIT_STR);
							messageStr = "";
							mode_ = MODE_MENU_ROOT;
							repaint();
							break;
						case Display.KEY_SOFT2 :
							switch (rSoftkey_) {
								case 0 :
									core.request(GBACore.REQUEST_SLEEP, 0);
									padDisp_ = true;
									setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_RET_STR);
									selectSubMenuNo_ = svSubMenuPadNo;
									mode_ = MODE_MENU_BUTTON_SET;
									repaint();
									break;
								case 1:
									boolean rYes = true;
									if ((confirmMsg_ & 4) != 0) {
										core.request(GBACore.REQUEST_SLEEP, 0);
										rYes = confirm("Zbg܂H");
									}
									if (rYes) {
										if (romload) {
											core.request(GBACore.REQUEST_RESET, 0);
										}
									} else {
										core.request(GBACore.REQUEST_START, 0);
									}
									break;
							}
							break;
						default :
							for (int i = 8; i < keyConfig_.length; i++) {
								for (int j = 0; j < keyConfig_[i].length; j++) {
									if (param == keyConfig_[i][j]) {
										switch (i) {
											case 8 :
												selectSubMenuNo_ = svSubMenuLoadNo;
												core.request(GBACore.REQUEST_SLEEP, 0);
												mode_ = MODE_MENU_LOAD;
												setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_ROM_STR);
												repaint();
												break;
											case 9 :
												selectSubMenuNo_ = svSubMenuSaveNo;
												core.request(GBACore.REQUEST_SLEEP, 0);
												mode_ = MODE_MENU_SAVE;
												setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_SAVE_STR);
												repaint();
												break;
											case 10 :
												if (frameSkip_ < 30) {
													frameSkip_++;
												}
												break;
											case 11 :
												if (frameSkip_ > 1) {
													frameSkip_--;
												}
												break;
											default :
												break;
										}
									}
								}
							}
							break;
					}
					break;

				case MODE_MENU_KEYCON_SET :
					keyConfigSet(param);
					break;

				default :
					keyPressMenu(param);
					break;
			}
		}

	}

	private void keyPressMenu(final int param) {
		String tmp;
		long wt = 700;
		long ct = 0;
		switch (param) {
			case Display.KEY_SOFT1 :
				if (mode_ != MODE_MENU_ROOT) {
					switch (mode_) {
						case MODE_MENU_ROMFILE :
							selectSubMenuNo_ = 7;
							mode_ = MODE_MENU_SETTING;
							break;
						case MODE_MENU_CONFIRM :
							selectSubMenuNo_ = 8;
							mode_ = MODE_MENU_SETTING;
							break;
						case MODE_MENU_LOAD :
							svSubMenuLoadNo = selectSubMenuNo_;
							mode_ = MODE_MENU_ROOT;
							break;
						case MODE_MENU_SAVE :
							svSubMenuSaveNo = selectSubMenuNo_;
							mode_ = MODE_MENU_ROOT;
							break;
						case MODE_MENU_SETTING :
							svSubMenuSettingNo = selectSubMenuNo_;
							mode_ = MODE_MENU_ROOT;
							break;
						case MODE_MENU_KEYCON :
							svSubMenuKeyConfNo = selectSubMenuNo_;
							mode_ = MODE_MENU_ROOT;
							break;
						case MODE_MENU_BUTTON_SET:
							svSubMenuPadNo = selectSubMenuNo_;
							mode_ = MODE_MENU_ROOT;
							break;
						case MODE_MENU_TOOLS:
							svSubMenuToolNo = selectSubMenuNo_;
							mode_ = MODE_MENU_ROOT;
							break;
						case MODE_MENU_EXPORT :
							svSubMenuExportNo = selectSubMenuNo_;
							selectSubMenuNo_ = 0;
							mode_ = MODE_MENU_TOOLS;
							break;
						case MODE_MENU_IMPORT :
							svSubMenuImportNo = selectSubMenuNo_;
							selectSubMenuNo_ = 1;
							mode_ = MODE_MENU_TOOLS;
							break;
						default :
							messageStr = "";
							mode_ = MODE_MENU_ROOT;
					}
					if (mode_ == MODE_MENU_ROOT) {
						setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_EXIT_STR);
					}else if (mode_ == MODE_MENU_SETTING) {
						setSoftLabel( Frame.SOFT_KEY_2 ,SOFTKEY_BGCOLOR_STR[menuBGcolor_]);
					} else {
						setSoftLabel(Frame.SOFT_KEY_2, null);
					}
				} else {
					messageStr = "";
					core.request(GBACore.REQUEST_START, 0);
					setRightSoftkeyLabel();
					displayClear = true;
					mode_ = MODE_GAME;
				}
				padDisp_ = false;
				repaint();
				break;

			case Display.KEY_SOFT2 :
				switch (mode_) {
					case MODE_MENU_ROOT :
						boolean rYes = true;
						if ((confirmMsg_ & 8) != 0) rYes = confirm("I܂H");
						if (rYes){
							core.request(GBACore.REQUEST_STOP, 0);
							IApplication.getCurrentApp().terminate();
						}
						break;
					case MODE_MENU_ROM :
						imeOn(sdRomnm_[selectSubMenuNo_].trim(), TextBox.DISPLAY_ANY, TextBox.KANA);
						break;
					case MODE_MENU_LOAD :
						tmp = saveStr_[selectSubMenuNo_].trim();
						if (!tmp.equals("")) imeOn(saveStr_[selectSubMenuNo_].trim(), TextBox.DISPLAY_ANY, TextBox.KANA);
						break;
					case MODE_MENU_SAVE :
						tmp = saveStr_[selectSubMenuNo_].trim();
						if (!tmp.equals("")){
							if (confirm("No." + (selectSubMenuNo_ + 1)
								+ "\n"
								+ saveStr_[selectSubMenuNo_]
								+ "\n폜܂H")) {
								messageStr = "f[^폜";
								setMessage(messageStr);
								SDbinding sd = new SDbinding();
								sd.deleteFile("NO" + formatNumber(selectSubMenuNo_ + 1, 2) + ".SAV");
								saveStr_[selectSubMenuNo_] = "";
								writeSPsaves(selectSubMenuNo_);
								messageStr = "";
								repaint();
							}
						}
						break;
					case MODE_MENU_SETTING :
						if (++menuBGcolor_ > 5) menuBGcolor_ = 0;
						setSoftLabel( Frame.SOFT_KEY_2 ,SOFTKEY_BGCOLOR_STR[menuBGcolor_]);
						writeSP();
						repaint();
						break;
					case MODE_MENU_KEYCON :
						 if (confirm("L[ݒNA܂H")) {
							 for (int i = 0; i < keyConfig_.length; i++) {
								 keyconStr_[i] = "";
								 keyStr2Vector(i);
							 }
							 writeSPkeys();
						 }
						 break;
					case MODE_MENU_BUTTON_SET:
						if (padDisp_){
							svSubMenuPadNo = selectSubMenuNo_;
							setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_PAD_STR);
							padDisp_ = false;
							core.request(GBACore.REQUEST_START, 0);
							displayClear = true;
							mode_ = MODE_GAME;
							repaint();
						}
						break;
					default :
						break;
				}
				break;

			case Display.KEY_1 :
			case Display.KEY_2 :
			case Display.KEY_3 :
			case Display.KEY_4 :
			case Display.KEY_5 :
			case Display.KEY_6 :
			case Display.KEY_7 :
			case Display.KEY_8 :
			case Display.KEY_9 :
			case Display.KEY_0 :
			case Display.KEY_ASTERISK :
			case Display.KEY_POUND :
				int pno;
				switch (param) {
				  case Display.KEY_0 :
					pno = 10;
					break;
				  case Display.KEY_ASTERISK :
				  case Display.KEY_POUND :
					pno = param + 1;
					break;
				  default :
					pno = param;
				}
				if (mode_ == MODE_MENU_ROOT) {
					if (pno > MENU_ROOT.length) {
						break;
					}
					selectMenuNo_ = pno - 1;
				} else {
					if (pno > subMenu_.length) {
						break;
					}
					selectSubMenuNo_ = pno - 1;
				}
				paint(g);
				// KEY_SELECT̓BbreakȂB
			case Display.KEY_SELECT :
				switch (mode_) {
					case MODE_MENU_ROOT :
						selectMenuRoot();
						break;
					case MODE_MENU_ROM :
						loadRom();
						break;
					case MODE_MENU_SAVE :
						save();
						break;
					case MODE_MENU_LOAD :
						tmp = saveStr_[selectSubMenuNo_].trim();
						if (romload) {
							if (tmp.equals("")){
								infomsg("Lȃf[^ł͂܂B");
							} else {
								boolean rYes = true;
								if ((confirmMsg_ & 1) != 0)
									rYes = confirm("No." + (selectSubMenuNo_ + 1)
										+ "\n" + saveStr_[selectSubMenuNo_] + "\n[h܂H");
								if (rYes) {
									messageStr = "f[^[h";
									setMessage(messageStr);
									core.request(GBACore.REQUEST_LOAD, selectSubMenuNo_ + 1);
									setRightSoftkeyLabel();
									svSubMenuLoadNo = selectSubMenuNo_;
									messageStr = "";
									displayClear = true;
									mode_ = MODE_GAME;
								}
							}
						} else {
							alert("ROMǍłɂĂ!!");
						}
						break;
					case MODE_MENU_EXPORT :
						tmp = saveStr_[selectSubMenuNo_].trim();
						if (tmp.equals("")){
							infomsg("Lȃf[^ł͂܂B");
						} else {
							messageStr = "f[^GIFo͒";
							setMessage(messageStr);
							exportGIF();
						}
						break;
					case MODE_MENU_IMPORT :
						messageStr = "f[^GIFǍ";
						setMessage(messageStr);
						importGIF();
						break;
					case MODE_MENU_SETTING :
						selectMenuSetting();
						break;
					case MODE_MENU_KEYCON :
						setSoftLabel(Frame.SOFT_KEY_2, null);
						// mode_ = MODE_MENU_KEYCON_SET;
						repaint();
						break;
					case MODE_MENU_BUTTON_SET :
						selectMenuButtonSetting();
						break;
					case MODE_MENU_ROMFILE :
						selectMenuRomFile();
						break;
					case MODE_MENU_CONFIRM :
						selectMenuConfirm();
						break;
					case MODE_MENU_TOOLS :
						selectMenuTools();
						break;
					default :
						break;
				}
				break;

			case Display.KEY_UP :
				while (getKeypadState() != 0){
					ct = System.currentTimeMillis();
					if (mode_ == MODE_MENU_ROOT) {
						selectMenuNo_ =
							incNo(selectMenuNo_, -1, MENU_ROOT.length);
					} else {
						selectSubMenuNo_ =
							incNo(
								selectSubMenuNo_,
								-1,
								subMenu_.length);
					}
					repaint();
					while (System.currentTimeMillis() - ct < wt) {
						if (getKeypadState() == 0) break;
						try {
							Thread.sleep(10L);
						} catch (Exception ex) {}
					}
					wt = 180;
				}
				break;

			case Display.KEY_DOWN :
				while (getKeypadState() != 0){
					ct = System.currentTimeMillis();
					if (mode_ == MODE_MENU_ROOT) {
						selectMenuNo_ =
							incNo(selectMenuNo_, +1, MENU_ROOT.length);
					} else {
						selectSubMenuNo_ =
							incNo(
								selectSubMenuNo_,
								+1,
								subMenu_.length);
					}
					repaint();
					while (System.currentTimeMillis() - ct < wt) {
						if (getKeypadState() == 0) break;
						try {
							Thread.sleep(10L);
						} catch (Exception ex) {}
					}
					wt = 180;
				}
				break;

			case Display.KEY_RIGHT :
				while (getKeypadState() != 0){
					ct = System.currentTimeMillis();
					switch (mode_) {
						case MODE_MENU_ROM:
							if (page_ < sdPage_ ){
								page_++;
							} else {
								page_ = 1;
							}
							readSdromNameSP(page_);
							break;
						case MODE_MENU_SETTING:
							if (selectSubMenuNo_ == 1){
								if (frameSkip_ < 30) frameSkip_++;
									else frameSkip_ = 1;
								svframeSkip_ = frameSkip_;
								writeSP();
							}
							break;
					}
					repaint();
					while (System.currentTimeMillis() - ct < wt) {
						if (getKeypadState() == 0) break;
						try {
							Thread.sleep(10L);
						} catch (Exception ex) {}
					}
					wt = 180;
				}
				break;

			case Display.KEY_LEFT :
				while (getKeypadState() != 0){
					ct = System.currentTimeMillis();
					switch(mode_) {
						case MODE_MENU_ROM:
							if (page_ > 1 ){
								page_--;
							} else {
								page_ = sdPage_;
							}
							readSdromNameSP(page_);
						case MODE_MENU_SETTING:
							if (selectSubMenuNo_ == 1){
								if (frameSkip_ > 1) frameSkip_--;
									else frameSkip_ = 30;
								svframeSkip_ = frameSkip_;
								writeSP();
							}
							break;
					}
					repaint();
					while (System.currentTimeMillis() - ct < wt) {
						if (getKeypadState() == 0) break;
						try {
							Thread.sleep(10L);
						} catch (Exception ex) {}
					}
					wt = 180;
				}
				break;

			default :
				break;
		}
	}

	//͎󂯎
	public void processIMEEvent(int type, String text) {
		if (type==IME_COMMITTED) {
			switch (mode_) {
				case MODE_MENU_ROM :
					// ROM̕ҏW
					text = formatSpace(text, SIZE_ROM_NAME);
					sdRomnm_[selectSubMenuNo_] = text;
					writeSdromNameSP((page_ - 1) * NUM_SDROM + selectSubMenuNo_, text);
					repaint();
					break;
				case MODE_MENU_LOAD :
					// Z[u̕ҏW
					if (!text.equals("")){
						text = formatSpace(text, SIZE_SAVE_NAME);
						saveStr_[selectSubMenuNo_] = text;
						writeSPsaves(selectSubMenuNo_);
						repaint();
					}
					break;

				case MODE_MENU_ROMFILE :
					// ROM̃C|[g
					if (selectSubMenuNo_ == 3 && !text.equals("")) {
						messageStr = "ROM̃C|[g";
						repaint();
						String[] romnm = split(text, '\n', MAX_SDROM_PAGE * NUM_SDROM);
						DataOutputStream out = null;
						try {
							out = Connector.openDataOutputStream(
									"scratchpad:///0;pos="
										+ (SIZE_SP_SETTING)
										+ ",length=" + SIZE_ROM_NAME * MAX_SDROM_PAGE * NUM_SDROM);
							for (int i=0; i<romnm.length; i++) {
								if (i > NUM_SDROM * sdPage_ - 1) break;
								out.write(formatSpace(romnm[i], SIZE_ROM_NAME).getBytes());
							}
							out.flush();
						} catch (Exception e) {
							alert("err writeInportSP: " + e);
						} finally {
							try {
								out.close();
								out = null;
							} catch (Exception ex) {
								out = null;
							}
						}
						messageStr = "";
					}
					repaint();
					break;
				default :
					break;
			}
		}
	}

	public void paint(final Graphics g) {
		try {

		if (mode_ == MODE_GAME) {
			if (displayClear) {
				g.setColor(Graphics.getColorOfName(Graphics.BLACK));
				g.fillRect(0, 0, getWidth(), getHeight());
				allG.setFlipMode(Graphics.FLIP_NONE);
				allG.setColor(Graphics.getColorOfName(Graphics.BLACK));
				allG.fillRect(0, 0, getWidth(), getHeight());
				displayClear = false;
			}
			if (flipMode_ == 0) {
				g.setRGBPixels((getWidth() - 240) / 2, 40, 240, 160, fb, 0);
				// 
				if (messageStr != null) {
					g.setColor(Graphics.getColorOfName(Graphics.BLACK));
					g.fillRect(0, 224, 240, 16);
					g.setColor(Graphics.getColorOfName(Graphics.WHITE));
					g.drawString(messageStr, 4, 224 + BASE_LINE);
					messageStr = null;
				}
			} else {
				// ʉ]
				switch (flipMode_) {
					case 1 :
						g.setFlipMode(Graphics.FLIP_ROTATE_RIGHT);
						break;
					case 2 :
						g.setFlipMode(Graphics.FLIP_ROTATE);
						break;
					case 3 :
						g.setFlipMode(Graphics.FLIP_ROTATE_LEFT);
						break;
					default :
						break;
				}
				allG.setRGBPixels((getWidth() - 240) / 2, 40, 240, 160, fb, 0);
				// 
				if (messageStr != null) {
					allG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					allG.fillRect(0, 224, 240, 16);
					allG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					allG.drawString(messageStr, 4, 224 + BASE_LINE);
					messageStr = null;
				}
				g.drawImage(allImg, 0, 0);
			}
		}else{
			paintMenu(g);
		}

		} catch (Exception ex) {
			//alert("err paint: " + ex);
		}
	}

	private void paintMenu(final Graphics g) {
		g.lock();
		switch (mode_) {
			case MODE_MENU_ROOT :
				menu(g, "Cj[", MENU_ROOT, selectMenuNo_,
					DEFAULT_FONT.stringWidth("pbh@\ݒ")+20);
				break;

			case MODE_MENU_ROM :
				subMenu_ = sdRomnm_;
				menu(g, "ROMI (PAGE " + page_ + "/" + sdPage_ + ")", subMenu_, selectSubMenuNo_,
					DEFAULT_FONT.stringWidth("                              ")+20);
				if (menuBGcolor_ >= 3) {
					messageStr = "(PAGE " + page_ + "/" + sdPage_ + ")";
				}
				break;

			case MODE_MENU_SAVE :
			case MODE_MENU_LOAD :
			case MODE_MENU_EXPORT :
			case MODE_MENU_IMPORT :
				String title = "";
				switch (mode_) {
					case MODE_MENU_LOAD :
						title = "f[^[h";
						break;
					case MODE_MENU_SAVE :
						title = "f[^Z[u";
						break;
					case MODE_MENU_EXPORT :
						title = "f[^GIFo";
						break;
					case MODE_MENU_IMPORT :
						title = "f[^GIFǍ";
						break;
					default :
						break;
				}
				subMenu_ = saveStr_;
				menu(g, title, subMenu_, selectSubMenuNo_,
					DEFAULT_FONT.stringWidth("                                  ")+20);
				break;

			case MODE_MENU_SETTING :
				int i = 0;
				if (!fpsOff_) i = 1;
				int j = 0;
				if (alpha_) j = 1;
				subMenu_ =
					new String[] {
						"FPS\         : " + ON_OFF_STR[i],
						"t[XLbv    : " + frameSkip_,
						"x(60FPS)   : " + FRAMES_STR[sleep_],
						"NOROMǍ   : " + ON_OFF_STR[startAndLoad_],
						"Q[ʂ̉]    : " + FLIPMODE_STR[flipMode_],
						"E\tgL[̋@\  : " + SOFTKEY_STR[rSoftkey_],
						"j[̓    : " + ON_OFF_STR[j],
						"ROMt@Cݒ",
						"mFbZ[Wݒ",
						};
				menu(g, "Sʐݒ", subMenu_, selectSubMenuNo_,
					DEFAULT_FONT.stringWidth("E\tgL[̋@\  : pbhݒ")+20);
				break;

			case MODE_MENU_KEYCON :
				subMenu_ = MENU_KEYCON;
				menu(g, "L[ݒ", subMenu_, selectSubMenuNo_,
                    DEFAULT_FONT.stringWidth("SELECT{^")+20);
				break;

			case MODE_MENU_KEYCON_SET :
				keyConfigWindow(g);
				break;

			case MODE_MENU_BUTTON_SET :
			{
				subMenu_ =
					new String[] {
						"A{^̘A       : " + ON_OFF_STR[aRen_],
						"A{^̃z[h   : " + ON_OFF_STR[aHold_],
						"A{^̘Aˁ{z[h",
						"B{^̘A       : " + ON_OFF_STR[bRen_],
						"B{^̃z[h   : " + ON_OFF_STR[bHold_],
						"B{^̘Aˁ{z[h"
					};
				menu(g, "pbh@\ݒ", subMenu_, selectSubMenuNo_,
                    DEFAULT_FONT.stringWidth("A{^̘A       : OFF")+20);
				break;
			}

			case MODE_MENU_TOOLS :
				subMenu_ =
					new String[] {
						"f[^GIFo",
						"f[^GIFǍ",
						"ʕۑ"
					};
				menu(g, "c[", subMenu_, selectSubMenuNo_,
                    DEFAULT_FONT.stringWidth("f[^GIFo")+20);
				break;

			case MODE_MENU_ROMFILE :
				subMenu_ =
					new String[] {
						"SDt@C쐬(+1y[W)",
						"SDt@C폜(-1y[W)",
						"ROM̂̃GNX|[g",
						"ROM̂̃C|[g",
						"SDJ[h󂫗eʂ̊mF"
						};
				menu(g, "ROMt@Cݒ :  " + sdPage_ + "PAGE" , subMenu_, selectSubMenuNo_,
                    DEFAULT_FONT.stringWidth("SDt@C쐬(+1y[W)")+20);
				break;

			case MODE_MENU_CONFIRM :
				subMenu_ =
					new String[] {
						"f[^[h      : " + ON_OFF_STR[confirmMsg_ & 1],
						"f[^Z[u      : " + ON_OFF_STR[(confirmMsg_ & 2) >> 1],
						"Zbg          : " + ON_OFF_STR[(confirmMsg_ & 4) >> 2],
						"I              : " + ON_OFF_STR[(confirmMsg_ & 8) >> 3],
						"Lׂ"
						};
				menu(g, "mFbZ[Wݒ", subMenu_, selectSubMenuNo_,
                    DEFAULT_FONT.stringWidth("f[^[h      : OFF")+20);
				break;

			default :
				break;
		}
		// 
		g.setColor(Graphics.getColorOfName(Graphics.BLACK));
		g.fillRect(0, 224, 240, 16);
		if (messageStr != null) {
			g.setColor(Graphics.getColorOfName(Graphics.WHITE));
			g.drawString(messageStr, 4, 224 + BASE_LINE);
		}
		g.unlock(true);
	}

	/*
	* drawMsg(), drawcTriangle(), drawChs()  Shoelace 炢܂ m(_ _)mZMo[Ŵ̂܂܎gĂ܂B݂܂
	*/
	//bZ[W\GA̕`
	public void drawMsg(final Graphics g, int xp,int yp,int whd,int hgt){
		//bZ[W\̘g`
		int[] x={xp,xp+2,xp+whd-2,xp+whd,xp+whd,xp+whd-2,xp+2,xp,xp};
		int[] y={yp+2,yp,yp,yp+2,yp+hgt-2,yp+hgt,yp+hgt,yp+hgt-2,yp+2};
		int[] x2={xp-1,xp+2,xp+whd-2,xp+whd+1,xp+whd+1,xp+whd-2,xp+2,xp-1,xp-1};
		int[] y2={yp+2,yp-1,yp-1,yp+2,yp+hgt-2,yp+hgt+1,yp+hgt+1,yp+hgt-2,yp+2};

		//bZ[W\lCr[œhԂ
		g.setColor(g.getColorOfRGB(0x33,0x33,0x77,0xCF));
		g.fillRect(xp,yp,whd,hgt);

		//bZ[Wg\
		g.setColor(g.getColorOfRGB(0x88,0x88,0x88));
		g.drawPolyline(x,y,9);
		g.setColor(g.getColorOfRGB(0xCC,0xCC,0xCC));
		g.drawPolyline(x2,y2,9);
	}

	//J[\̕`
	public void drawcTriangle(final Graphics g, int xp,int yp){
		int[] x={xp,xp+6,xp,xp};
		int[] y={yp,yp+4,yp+8,yp};

		g.setColor(g.getColorOfRGB(0xFF,0xFF,0xFF));
		g.fillPolygon(x,y,4);
	}

	//EBhE̕`
	public void drawChs(final Graphics g, String[] sChois, int x, int y, int whd){
		g.setFont(DEFAULT_FONT);
		int myp = y + HEIGHT_LINE;
		drawMsg(g, x,y,whd,(HEIGHT_LINE*sChois.length)+7);
		g.setColor(g.getColorOfRGB(0xFF,0xFF,0xFF));
		for(int i=0; i<sChois.length; i++) g.drawString(sChois[i], x + 17, myp + (i * HEIGHT_LINE));
	}

	private void menu(final Graphics g, final String title, final String[] menu, final int select, final int windowWidth) {
		g.setFont(DEFAULT_FONT);
		g.setColor(Graphics.getColorOfName(Graphics.BLACK));
		g.fillRect(0, 0, getWidth(), getHeight());
		// wi
		if (alpha_) {
			g.setRGBPixels((getWidth() - 240) / 2, 40, 240, 160, fb, 0);
			if ((menuBGcolor_ % 3) == 0) { // 0, 3
				g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x44, 0xAA));//BLUE -alpha
			} else if ((menuBGcolor_ % 3) == 1) { // 1, 4
				g.setColor(Graphics.getColorOfRGB(0x22, 0x22, 0x22, 0xCF));//GRAY -alpha
			} else { // 2, 5
				g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00, 0xAA));//BLACK -alpha
			}
		}else{
			if ((menuBGcolor_ % 3) == 0) { // 0, 3
				g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x55));//BLUE
			} else if ((menuBGcolor_ % 3) == 1) { // 1, 4
				g.setColor(Graphics.getColorOfRGB(0x33, 0x33, 0x33));//GRAY
			} else { // 2, 5
				g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00));//BLACK
			}
		}
		if (menuBGcolor_ >= 3) {
			g.fillRect(0, 0, getWidth(), getHeight());
			//ShoelaceEBhE
			int shoeX = 5;
			int shoeY = 5;
/*
			if (isReverse())
				shoeX += (MENU_WIDTH - 320) / 2;
*/
			drawChs(g, menu, shoeX, shoeY, windowWidth);
			drawcTriangle(g, shoeX + 5, HEIGHT_LINE * (select + 1) - 5);
		} else {
			g.fillRect(0, HEIGHT_LINE, getWidth(), getHeight() - HEIGHT_LINE - 16);
			//j[^CgF
			if (menuBGcolor_ == 0) {
				g.setColor(Graphics.getColorOfRGB(0x55, 0x55, 0xAA));
			} else if (menuBGcolor_ == 1) {
				g.setColor(Graphics.getColorOfRGB(0x88, 0x88, 0x88));
			} else {
				g.setColor(Graphics.getColorOfRGB(0xA, 0xF, 0x41));
		   	}
			g.fillRect(0, 0, getWidth(), HEIGHT_LINE);
			g.setColor(Graphics.getColorOfName(Graphics.BLACK));
			g.drawString(title, 2, BASE_LINE);
			g.drawString(title, 3, BASE_LINE - 1);
			g.drawString(title, 4, BASE_LINE);
			g.drawString(title, 3, BASE_LINE + 1);
			g.setColor(Graphics.getColorOfName(Graphics.WHITE));
			g.drawString(title, 3, BASE_LINE);

			for (int i = 0; i < menu.length; i++) {
				if (i == select) {
					// Is̔wi
					if (menuBGcolor_ == 0) {
						g.setColor(Graphics.getColorOfRGB(0xdd, 0xdd, 0xff));
					} else if (menuBGcolor_ == 1) {
						g.setColor(Graphics.getColorOfRGB(0xdd, 0xdd, 0xdd));
					} else {
						g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0xC0));
					}
					g.fillRect(0, HEIGHT_LINE * (i + 1), getWidth(), HEIGHT_LINE);
					//I̕F
				  	if (menuBGcolor_ == 0) {
						g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x88));
					} else if (menuBGcolor_ == 1) {
						g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00));
					} else if (menuBGcolor_ == 2) {
						g.setColor(Graphics.getColorOfRGB(0xff, 0xff, 0xff));
					}
				} else {
					g.setColor(Graphics.getColorOfName(Graphics.WHITE));
				}
				// j[
				String num;
				if (i < 10) {
					num = "[" + (i + 1) % 10 + "] ";
				} else {
					switch (i){
						case 10 :
							num = "[*] ";
							break;
						case 11 :
							num = "[#] ";
							break;
						default :
							num = "[-] ";
							break;
					}
				}
				String romno = "";
				if (mode_ == MODE_MENU_ROM){
					romno = formatNumber((page_ - 1) * NUM_SDROM + i + 1, 3) + " ";
				}
				g.drawString(num + romno + menu[i], 4, HEIGHT_LINE * (i + 1) + BASE_LINE);
			}
		}
	}

	private void keyConfigWindow(final Graphics g) {
		// ݒ
		if (menuBGcolor_ == 0) { // wi
			g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x55));
		}else{
			g.setColor(Graphics.getColorOfRGB(0x33, 0x33, 0x33));
		}
		g.fillRect(0, 0, getWidth(), getHeight() - 16);

		g.setColor(Graphics.getColorOfName(Graphics.WHITE));
		g.drawString(MENU_KEYCON[selectSubMenuNo_] + " Ɋ蓖ĂL[", 10, 50);
		g.drawString("ĂB", 10, 50 + HEIGHT_LINE);
		g.drawString("ݒl:" + keyconStr_[selectSubMenuNo_], 10, 50 + HEIGHT_LINE * 2);
	}

	private void selectMenuRoot() {
		boolean rYes = true;
		switch (selectMenuNo_ + 1) {
			case 1 : // ROMI
				setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_ROM_STR);
				page_ = sdNo_ / NUM_SDROM + 1;
				selectSubMenuNo_ = sdNo_ % NUM_SDROM;
				readSdromNameSP(page_);
				mode_ = MODE_MENU_ROM;
				break;

			case 2 : // LOAD
				selectSubMenuNo_ = svSubMenuLoadNo;
				setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_ROM_STR);
				mode_ = MODE_MENU_LOAD;
				break;

			case 3 : // SAVE
				selectSubMenuNo_ = svSubMenuSaveNo;
				setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_SAVE_STR);
				mode_ = MODE_MENU_SAVE;
				break;

			case 4 : // RESET
				if ((confirmMsg_ & 4) != 0) rYes = confirm("Zbg܂H");
				if (rYes) {
					if (romload) {
						core.request(GBACore.REQUEST_RESET, 0);
						setRightSoftkeyLabel();
						displayClear = true;
						mode_ = MODE_GAME;
					}
				}
				break;

			case 5 : // ݒ
				selectSubMenuNo_ = svSubMenuSettingNo;
				frameSkip_ = svframeSkip_;
				setSoftLabel( Frame.SOFT_KEY_2 ,SOFTKEY_BGCOLOR_STR[menuBGcolor_]);
				mode_ = MODE_MENU_SETTING;
				break;

			case 6 : // KeyConfig
				selectSubMenuNo_ = svSubMenuKeyConfNo;
				setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_KEYSET_STR);
				mode_ = MODE_MENU_KEYCON;
				break;

			case 7 : // {^@\ݒ
				selectSubMenuNo_ = svSubMenuPadNo;
				setSoftLabel(Frame.SOFT_KEY_2, null);
				mode_ = MODE_MENU_BUTTON_SET;
				break;

			case 8 : // c[
				selectSubMenuNo_ = svSubMenuToolNo;
				setSoftLabel(Frame.SOFT_KEY_2, null);
				mode_ = MODE_MENU_TOOLS;
				break;

			case 9 : // o[W
				infomsg(VERSION_STR);
				break;

			default :
				break;
		}
		repaint();
	}

	private void selectMenuSetting() {
		int select = selectSubMenuNo_ + 1;
		switch (select) {
			case 1 : // ](gO)
				fpsOff_ = !fpsOff_;
				break;

			case 2 : // fs
				if (frameSkip_ < 30) frameSkip_++;
					else frameSkip_ = 0;
				svframeSkip_ = frameSkip_;
				break;

			case 3 : // x(60FPS)
				if (sleep_ < 2) {
					sleep_++;
				} else {
					sleep_ = 0;
				}
				break;

			case 4 : // NɑOROMǂݍނ
				startAndLoad_ = (startAndLoad_ + 1) & 1;
				break;

			case 5 : // ʂ̉]
				if (flipMode_ < 3) {
					flipMode_++;
				} else {
					flipMode_ = 0;
				}
				break;

			case 6 : // Eķ@\
				if (rSoftkey_ < 2) {
					rSoftkey_++;
				} else {
					rSoftkey_ = 0;
				}
				if (rSoftkey_ == 2) {
					skeyMask_ = 0xFFFFFFFF;
				} else {
					skeyMask_ = 0xFFBFFFFF;
				}
				break;

			case 7 : // j[̓
				alpha_ = !alpha_;
				break;

			case 8 : // ROMt@Cݒ
				selectSubMenuNo_ = 0;
				mode_ = MODE_MENU_ROMFILE;
				setSoftLabel(Frame.SOFT_KEY_2, null);
				break;

			case 9 : // mFbZ[W
				selectSubMenuNo_ = 0;
				mode_ = MODE_MENU_CONFIRM;
				setSoftLabel(Frame.SOFT_KEY_2, null);
				break;
			default :
				break;
		}
		writeSP();
		repaint();
	}

	private void selectMenuTools() {
		int select = selectSubMenuNo_ + 1;
		switch (select) {
			case 1 : // EXPORT
				svSubMenuToolNo = selectSubMenuNo_;
				selectSubMenuNo_ = svSubMenuExportNo;
				setSoftLabel(Frame.SOFT_KEY_2, null);
				mode_ = MODE_MENU_EXPORT;
				break;

			case 2 : // IMPORT
				svSubMenuToolNo = selectSubMenuNo_;
				selectSubMenuNo_ = svSubMenuImportNo;
				setSoftLabel(Frame.SOFT_KEY_2, null);
				mode_ = MODE_MENU_IMPORT;
				break;

			case 3 : // XN[Vbg
				svSubMenuToolNo = selectSubMenuNo_;
				messageStr = "ʕۑ";
				repaint();
				saveScreenShot();
				messageStr = "";
				break;

			default :
				break;
		}
		repaint();
	}

	private void selectMenuRomFile() {
		int select = selectSubMenuNo_ + 1;
		switch (select) {
			case 1 : // SDt@C쐬
				if (sdPage_ < MAX_SDROM_PAGE) {
					if (confirm("SDJ[hɃt@C쐬܂H")) {
						sdPage_++;
						messageStr = "_~[t@C(y[W" + sdPage_ + ")쐬";
						repaint();
						createSdfiles(sdPage_);
						writeSP();
						messageStr = "";
					}
				} else {
					infomsg("őy[WɒB܂B");
				}
				break;

			case 2 : // SDt@C폜
				if (sdPage_ > 1) {
					if (confirm("SDJ[h̃t@C폜܂H\n납1y[W" + NUM_SDROM + "t@C폜")) {
						messageStr = "SDt@C(y[W" + sdPage_ + ")폜";
						repaint();
						deleteSdfiles(sdPage_);
						sdPage_--;
						if (sdNo_ > sdPage_ * NUM_SDROM) sdNo_ = 0;
						writeSP();
						messageStr = "";
					}
				} else {
					infomsg("ŏy[WɒB܂B");
				}
				break;

			case 3 : // ROMGNX|[g
				String eXstr = "";
				messageStr = "ROM̃GNX|[g";
				repaint();
				for(int i=0; i<sdPage_; i++){
					readSdromNameSP(i + 1);
					for(int j=0; j<NUM_SDROM; j++) eXstr = eXstr + sdRomnm_[j].trim() + "\n";
				}
				imeOn(eXstr, TextBox.DISPLAY_ANY, TextBox.KANA);
				messageStr = "";
				break;

			case 4 : // ROMC|[g
				if (confirm("ROM̂C|[g܂H")) {
					imeOn("", TextBox.DISPLAY_ANY, TextBox.KANA);
				}
				break;

			case 5 : // 󂫗eʂ̊mF
				SDbinding sd = new SDbinding();
				long fs = sd.sdGetFreeSize() / 1024;
				infomsg("SDJ[h󂫗eʁF" + fs + "KB");
				break;

			default :
				break;
		}
		repaint();
	}

	private void selectMenuConfirm() {
		// mFbZ[Wݒ
		int select = selectSubMenuNo_ + 1;
		switch (select) {
			case 1 :
				confirmMsg_ ^= 1;
				break;
			case 2 :
				confirmMsg_ ^= 2;
				break;
			case 3 :
				confirmMsg_ ^= 4;
				break;
			case 4 :
				confirmMsg_ ^= 8;
				break;
			default :
				if ((confirmMsg_ & 0xFF) == 0xC0) {
					confirmMsg_ = 0xFF;
				} else {
					confirmMsg_ = 0xC0;
				}
				break;
		}
		writeSP();
		repaint();
	}

	private void selectMenuButtonSetting() {
		// pbh@\ݒ
/*
		int select = selectSubMenuNo_ + 1;
		switch (select) {
			case 1 :
				aRen_ = (aRen_ + 1) & 1;
				break;

			case 2 :
				aHold_ = (aHold_ + 1) & 1;
				break;

			case 3 :
				if (aRen_ != 0 && aHold_ != 0) {
					aRen_ = 0;
					aHold_ = 0;
				} else {
					aRen_ = 1;
					aHold_ = 1;
				}
				break;

			case 4 :
				bRen_ = (bRen_ + 1) & 1;
				break;

			case 5 :
				bHold_ = (bHold_ + 1) & 1;
				break;

			case 6 :
				if (bRen_ != 0 && bHold_ != 0) {
					bRen_ = 0;
					bHold_ = 0;
				} else {
					bRen_ = 1;
					bHold_ = 1;
				}
				break;

			default :
				break;
		}
		repaint();
*/
	}

	private void keyConfigSet(final int button) {
		// ݒ
		if (button != Display.KEY_SOFT1) {
			if (!keyconStr_[selectSubMenuNo_].startsWith(button + ",")
				&& (keyconStr_[selectSubMenuNo_].indexOf("," + button + ",")
					< 0)) {

				keyconStr_[selectSubMenuNo_] += button + ",";
				keyStr2Vector(selectSubMenuNo_);
				writeSPkeys();
			}
		}
		mode_ = MODE_MENU_KEYCON;
		setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_KEYSET_STR);
		repaint();
	}

	private void setRightSoftkeyLabel() {
		switch (rSoftkey_) {
			case 0 :
				setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_PAD_STR);
				break;
			case 1 :
				setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_RESET_STR);
				break;
			default :
				setSoftLabel(Frame.SOFT_KEY_2, null);
		}
	}

	private void createSdfiles(final int page) {
		//_~[SDt@C쐬
		int j = (page - 1) * NUM_SDROM + 1;
		SDbinding sd = new SDbinding();
		for(int i = j; i < j + NUM_SDROM; i++){
			sd.createFile(formatNumber(i, 3) + ".GBA");
		}
	}

	private void createBiosfile() {
		//_~[BIOS쐬
		SDbinding sd = new SDbinding();
		sd.createFile("BIOS.BIN");
	}

	private void deleteSdfiles(final int page) {
		//_~[SDt@C폜
		int j = (page - 1) * NUM_SDROM + 1;
		SDbinding sd = new SDbinding();
		for(int i = j; i < j + NUM_SDROM; i++){
			sd.deleteFile(formatNumber(i, 3) + ".GBA");
			writeSdromNameSP(i - 1, "");
			sdRomadj_[i - 1] = 0;
		}
		writeSPadjusts();
	}

	private void saveScreenShot() {
		//XN[Vbg
		Image ig = Image.createImage(240, 160);
		(ig.getGraphics()).setRGBPixels(0, 0, 240, 160, fb, 0);
		try{
			ImageEncoder ie = ImageEncoder.getEncoder("JPEG");
			ie.setAttribute(0, 0);
			EncodedImage ei = ie.encode(ig, 0, 0, 240, 160);
			MediaImage mi = ei.getImage();
			mi.use();
			ImageStore.addEntry(mi);
			mi.unuse();
			mi.dispose();
		}catch(Exception e){
			alert("err screenshot: " + e);
		}
	}

	private void save() {
		if (romload) {
			boolean rYes = true;
			if ((confirmMsg_ & 2) != 0)
				rYes = confirm("No." + (selectSubMenuNo_ + 1)
					+ "\n"
					+ saveStr_[selectSubMenuNo_]
					+ "\nɃZ[u܂H");
			if (rYes) {
				messageStr = "f[^Z[u";
				setMessage(messageStr);
				writeSaveDate();
				core.request(GBACore.REQUEST_SAVE, selectSubMenuNo_ + 1);
				setRightSoftkeyLabel();
				svSubMenuSaveNo = selectSubMenuNo_;
				svSubMenuLoadNo = selectSubMenuNo_;
				messageStr = "";
				displayClear = true;
				mode_ = MODE_GAME;
				//repaint();
			}
		} else {
			alert("ROMǍłɂĂ!!");
		}
	}

	private void writeSaveDate() {
		// SaveAGameSPۑ
		Calendar cal = Calendar.getInstance();
		saveStr_[selectSubMenuNo_] = formatSpace(
			formatNumber(cal.get(Calendar.MONTH) + 1, 2)
				+ "/"
				+ formatNumber(cal.get(Calendar.DATE), 2)
				+ " "
				+ formatNumber(cal.get(Calendar.HOUR_OF_DAY), 2)
				+ ":"
				+ formatNumber(cal.get(Calendar.MINUTE), 2)
				+ " "
				+ saveRomName, SIZE_SAVE_NAME);
		writeSPsaves(selectSubMenuNo_);
	}

	private void loadRom() {
		setMessage("ROMt@Cǂݍݒ");
		SDbinding sd = null;
		InputStream is = null;
		try {
			int romNo;
			String fnm;
			//GBACore̍ċN
			core.request(core.REQUEST_STOP, 0);
			core = new GBACore(this);

			romNo = selectSubMenuNo_;
			fnm = formatNumber((page_ - 1) * NUM_SDROM + romNo + 1, 3) + ".GBA";
			System.gc();
			sd = new SDbinding();
			is = sd.openInputStream(fnm);
			if (is != null) {
				int c = core.loadROM(is, sd.getFileSize());
				if (c == 0) {
					if (sdRomnm_[romNo].equals(formatSpace(" ",30))) {
						sdRomnm_[romNo] = core.rom_name;
						saveRomName = core.rom_name;
					} else {
						saveRomName = sdRomnm_[romNo];
					}
					sdNo_ = (page_ - 1) * NUM_SDROM + selectSubMenuNo_;
					setRightSoftkeyLabel();
					romload = true;
					displayClear = true;
					messageStr = "";
					writeSP();
					writeSdromNameSP((page_ - 1) * NUM_SDROM + romNo ,saveRomName);
					mode_ = MODE_GAME;
					core.reset();
					core.start();
					core.request(core.REQUEST_START, 0);
				}
				else {
					if (c == -1)
						alert("GBAt@Cł͂܂B");
					else if (c == -2)
						alert("BIOSt@CsłB");
				}
			}
			else {
				if (confirm("ROMt@Cǂݍ߂܂B\n_~[t@Cč쐬܂H\n("
							 + sdPage_ + "y[W" + (sdPage_ * NUM_SDROM) + "t@C)")) {
					for (int i = 1; i <= sdPage_; i++) {
						messageStr = "_~[t@C(y[W" + i + ")쐬";
						repaint();
						createSdfiles(i);
						createBiosfile();
					}
				}
				messageStr = "";
				repaint();
			}
		} catch (Exception e) {
			alert("err loadRom: " + e);
		} catch (Error err) {
			alert("err loadRomError: " + err);
			throw err;
		} finally {
			is = null;
			sd.close();
			sd = null;
			//SDbinding.closeFileEntry();
		}
	}

	private void exportGIF() {
		final byte[] GIF_FOOTER = { 0x00, 0x3B };

		SDbinding sd = null;
		DataInputStream in = null;
		try {
			// ScratchPadbyteǂݍ
			byte[] inData = new byte[SIZE_SAVE];
			sd = new SDbinding();
			in = sd.openDataInputStream(getSaveFile(selectSubMenuNo_ + 1));
			if (in == null) {
				alert("t@CǍ݂Ɏs܂B");
				return;
			}
			in.read(inData);

			// ubN쐬
			int blocksSize = inData.length / EXPORT_BLOCK_SIZE;
			int lastBlockLength = inData.length % EXPORT_BLOCK_SIZE;
			boolean lastBlockExists = false;

			if (lastBlockLength != 0) {
				lastBlockExists = true;
			}
			int lastCnt = 0;
			if (lastBlockExists) {
				lastCnt = 1;
			}

			// o̓f[^
			byte[] outData =
				new byte[GIF_HEADER.length
					+ inData.length
					+ blocksSize
					+ lastCnt
					+ GIF_FOOTER.length];

			// GIFwb_
			System.arraycopy(GIF_HEADER, 0, outData, 0, GIF_HEADER.length);
			int outCnt = GIF_HEADER.length;

			// RgubNDataۑ
			int inCnt = 0;
			for (int i = 0; i < blocksSize; i++) {
				// ubNTCY
				outData[outCnt] = EXPORT_BLOCK_SIZE - 0x100;
				outCnt++;

				System.arraycopy(
					inData,
					inCnt,
					outData,
					outCnt,
					EXPORT_BLOCK_SIZE);
				outCnt += EXPORT_BLOCK_SIZE;
				inCnt += EXPORT_BLOCK_SIZE;
			}

			// Ō̃ubN
			if (lastBlockExists) {
				outData[outCnt] = (byte) lastBlockLength;
				outCnt++;

				System.arraycopy(
					inData,
					inCnt,
					outData,
					outCnt,
					lastBlockLength);
				outCnt += lastBlockLength;
				inCnt += lastBlockLength;
			}

			// GIFtb^
			System.arraycopy(GIF_FOOTER, 0, outData, outCnt, GIF_FOOTER.length);

			// GIFo
			//System.out.println("size:" + outData.length);
			//for (int i = 0; i < 100; i++) {
			//	System.out.print(Integer.toHexString(outData[i])  + ", ");
			//}
			//System.out.println("footer:");
			//for (int i = outData.length - 100; i < outData.length; i++) {
			//	System.out.print(Integer.toHexString(outData[i]) + ", ");
			//}

			MediaImage mediaImage = MediaManager.getImage(outData);
			mediaImage.use();
			ImageStore.addEntry(mediaImage);
			mediaImage.unuse();
			mediaImage.dispose();
		} catch (Exception e) {
			alert("err exportGIF: " + e);
		} finally {
			in = null;
			sd.close();
			sd = null;
		}
		//mode_ = MODE_MENU_ROOT;
		messageStr = "";
		repaint();
	}

	private void importGIF() {
		byte[] importData = new byte[SIZE_SAVE];
		int importedSize = 0;

		InputStream is = null;
		try {
			ImageStore istore = ImageStore.selectEntry();
			if (istore == null) {
				return;
			}
			is = istore.getInputStream();

			byte[] header = new byte[6];
			is.read(header);

			// GIF̂
			if (new String(header).equals("GIF89a")) {
				// RgubN܂skip
				is.skip(GIF_HEADER.length - 6);

				int length = is.available();
				//System.out.println("length:" + length);

				boolean last = false;
				while (!last) {
					int size = is.read();
					//System.out.println("size:" + size);
					if (size != EXPORT_BLOCK_SIZE) {
						last = true;
					}

					byte[] block = new byte[size];
					is.read(block);
					if (importedSize + size > importData.length) {
						alert("length is over:" + length);
						return;
					}
					System.arraycopy(block, 0, importData, importedSize, size);
					importedSize += size;
				}
				// tb^͖B
			} else {
				alert("not GIF");
				return;
			}
		} catch (Exception e) {
			alert("err importGIF: " + e);
			return;
		} finally {
			try {
				is.close();
				is = null;
			} catch (Exception ex) {
				is = null;
			}
		}
		
		SDbinding sd = null;
		DataOutputStream out = null;
		try{
			sd = new SDbinding();
			out = sd.openDataOutputStream(getSaveFile(selectSubMenuNo_ + 1));
			if (out == null) {
				alert("t@C݂Ɏs܂B");
			}
			out.write(importData, 0, importData.length);
			out.flush();

			writeSaveDate();

		} catch (Exception e) {
			alert("err importGIF: " + e);
		} finally {
			out = null;
			sd.close();
			sd = null;
		}
		//mode_ = MODE_MENU_ROOT;
		messageStr = "";
		repaint();
	}

	private void readSP() {
		DataInputStream in = null;
		DataOutputStream out = null;
		try {
			in = Connector.openDataInputStream(
					"scratchpad:///0;pos=0,length="
						+ SIZE_SP_OTHERS);

			// VERSION擾
			int version = in.readInt();
			//NtO
			firstExec_ = in.readBoolean();
			if (version != VERSION) {
				in.close();
				in = null;

				out = Connector.openDataOutputStream(
						"scratchpad:///0;pos=0,length="
							+ SIZE_SP_SETTING);

				byte[] noData = new byte[SIZE_SP_SETTING];
				for (int i = 0; i < noData.length; i++) {
					noData[i] = 0;
				}
				out.write(noData);
				out.flush();
				out.close();

				out = Connector.openDataOutputStream(
						"scratchpad:///0;pos=0,length=5");
				out.writeInt(VERSION);
				out.writeBoolean(firstExec_);
				out.flush();
				out.close();

				in = Connector.openDataInputStream(
						"scratchpad:///0;pos=0,length="
							+ SIZE_SP_OTHERS);
				version = in.readInt();
				firstExec_ = in.readBoolean();
			}
			// FSAFPS\
			frameSkip_ = in.readInt();
			fpsOff_ = in.readBoolean();
			// NROMǂݍ
			startAndLoad_ = in.readInt();
			// ʉ]
			flipMode_ = in.readInt();
			// mFbZ[W
			confirmMsg_ = in.readInt();
			if ((confirmMsg_ & 0xC0) == 0) confirmMsg_ = 0xFE;
			// OSDROMԍ
			sdNo_ = in.readInt();
			// SDt@Cy[W
			sdPage_ = in.readInt();
			// j[
			alpha_ = in.readBoolean();
			// x(60FPS)
			sleep_ = in.readInt();
			// Eķ@\
			rSoftkey_ = in.readInt();
			if (rSoftkey_ == 4) {
				skeyMask_ = 0xFFFFFFFF;
			} else {
				skeyMask_ = 0xFFBFFFFF;
			}
			// j[wiF
			menuBGcolor_ = in.readInt();

			/////////////////////////////
			// ftHglݒ
			/////////////////////////////

			// 0ɂȂ̂ŃftHgl5ɂB
			if (frameSkip_ == 0) {
				frameSkip_ = 5;
			}
			svframeSkip_ = frameSkip_;
		} catch (Exception e) {
			alert("err readSP: " + e);
		} finally {
			try {
				in.close();
				in = null;
				out.close();
				out = null;
			} catch (Exception ex) {
				in = null;
				out = null;
			}
		}

	}

	private void readSPkeys() {
		// keyconfig
		DataInputStream in = null;
		try {
			in = Connector.openDataInputStream(
					"scratchpad:///0;pos="
						+ SIZE_SP_OTHERS
						+ ",length="
						+ SIZE_SP_KEYS);

			byte[] key = new byte[20];
			for (int i = 0; i < keyconStr_.length; i++) {
				in.read(key);
				if (key[0] == 0) {
					keyconStr_[i] = "";
				} else {
					keyconStr_[i] = new String(key).trim();
				}
				keyStr2Vector(i);
			}
/*̂
			// ͋œĂ̂ŏ
			if (keyconStr_[0].equals("")) {
				keyconStr_ =
					new String[] {
						Display.KEY_3 + "," + Display.KEY_SELECT + ",",
						Display.KEY_2 + "," + Display.KEY_SOFT2 + ",",
						Display.KEY_5 + ",",
						Display.KEY_6 + ",",
						Display.KEY_UP + ",",
						Display.KEY_DOWN + ",",
						Display.KEY_LEFT + ",",
						Display.KEY_RIGHT + ",",
						Display.KEY_0 + ",",
						Display.KEY_8 + ",",
						Display.KEY_1 + ",",
						Display.KEY_4 + ",",
					};

				for (int i = 0; i < keyConfig_.length; i++) {
					keyStr2Vector(i);
				}
				in.close();
				writeSPkeys();
			}
*/
		} catch (Exception e) {
			alert("err readSPkeys: " + e);
		} finally {
			try {
				in.close();
				in = null;
			} catch (Exception ex) {
				in = null;
			}
		}

	}

	private void readSPsaves() {
		// Z[u
		DataInputStream in = null;

		try {
			in = Connector.openDataInputStream(
					"scratchpad:///0;pos="
						+ (SIZE_SP_OTHERS + SIZE_SP_KEYS)
						+ ",length="
						+ SIZE_SP_SAVES);
			byte[] save = new byte[SIZE_SAVE_NAME];
			for (int i = 0; i < NUM_SAVE; i++) {
				in.read(save);
				if (save[0] == 0) {
					saveStr_[i] = "";
				} else {
					saveStr_[i] = new String(save);
				}
			}
		} catch (Exception e) {
			alert("err readSPsaves: " + e);
		} finally {
			try {
				in.close();
				in = null;
			} catch (Exception ex) {
				in = null;
			}
		}

	}

	private void readSPadjusts() {
		// Z[u
		DataInputStream in = null;
		try {
			in = Connector.openDataInputStream(
					"scratchpad:///0;pos="
						+ (SIZE_SP_OTHERS + SIZE_SP_KEYS + SIZE_SP_SAVES)
						+ ",length="
						+ SIZE_SP_ADJUST);
			byte[] data = new byte[SIZE_SP_ADJUST];
			in.read(data);
			for(int i = 0, pos = 0; i < (NUM_SDROM * MAX_SDROM_PAGE); i++, pos++) {
				if((pos % 2) == 0) {
					sdRomadj_[i] = (int)((data[pos >> 1] >> 4) & 0xF) - 8;
				} else {
					sdRomadj_[i] = (int)((data[pos >> 1]) & 0xF) - 8;
				}
				if(sdRomadj_[i] < -5 || sdRomadj_[i] > 5) sdRomadj_[i] = 0;
			}
		} catch (Exception e) {
			alert("err readSPsaves: " + e);
		} finally {
			try {
				in.close();
				in = null;
			} catch (Exception ex) {
				in = null;
			}
		}
	}

	private void readSdromNameSP(final int page) {
		DataInputStream in = null;

		try {
			in = Connector.openDataInputStream(
					"scratchpad:///0;pos="
						+ (SIZE_SP_SETTING + (SIZE_ROM_NAME * NUM_SDROM) * (page - 1))
						+ ",length=" + SIZE_ROM_NAME * NUM_SDROM);
			byte[] name = new byte[SIZE_ROM_NAME];
			for (int i = 0; i < NUM_SDROM; i++) {
				in.read(name);
				if (name[0] == 0) {
					sdRomnm_[i] = formatSpace(" ",30);
				} else {
					sdRomnm_[i] = new String(name);
				}
			}
		} catch (Exception e) {
			alert("err readSdromNameSP: " + e);
		} finally {
			try {
				in.close();
				in = null;
			} catch (Exception ex) {
				in = null;
			}
		}
	}

	private void writeSP() {
		DataOutputStream out = null;
		try {
			out = Connector.openDataOutputStream(
					"scratchpad:///0;pos=0,length=" + SIZE_SP_OTHERS);
			// VERSIONF4byte
			out.writeInt(VERSION);
			// NtO
			out.writeBoolean(firstExec_);
			// FSF4byte
			out.writeInt(svframeSkip_);
			// FPS\F1byte
			out.writeBoolean(fpsOff_);
			// NROMǂݍ
			out.writeInt(startAndLoad_);
			// ʉ]
			out.writeInt(flipMode_);
			// mFbZ[W
			out.writeInt(confirmMsg_);
			// OSDROMԍ
			out.writeInt(sdNo_);
			// SDt@Cy[W
			out.writeInt(sdPage_);
			// j[
			out.writeBoolean(alpha_);
			// x(60FPS)F4byte
			out.writeInt(sleep_);
			// Eķ@\F4byte
			out.writeInt(rSoftkey_);
			// j[wiF
			out.writeInt(menuBGcolor_);
			out.flush();
		} catch (Exception e) {
			alert("err writeSP: " + e);
		} finally {
			try {
				out.close();
				out = null;
			} catch (Exception ex) {
				out = null;
			}
		}
	}

	private void writeSPkeys() {
		// keyconfigF20byte ~ 12 = 240
		DataOutputStream out = null;
		try {
			out = Connector.openDataOutputStream(
					"scratchpad:///0;pos="
						+ SIZE_SP_OTHERS
						+ ",length="
						+ SIZE_SP_KEYS);
			for (int i = 0; i < keyconStr_.length; i++) {
				out.write(formatSpace(keyconStr_[i], 20).getBytes());
			}
			out.flush();
		} catch (Exception e) {
			alert("err writeSPkeys: " + e);
		} finally {
			try {
				out.close();
				out = null;
			} catch (Exception ex) {
				out = null;
			}
		}
	}

	private void writeSPsaves(final int sno) {
		// Z[u
		DataOutputStream out = null;
		try {
			out = Connector.openDataOutputStream(
					"scratchpad:///0;pos="
						+ (SIZE_SP_OTHERS + SIZE_SP_KEYS + SIZE_SAVE_NAME * sno)
						+ ",length="
						+ SIZE_SAVE_NAME);
			byte[] data = formatSpace(saveStr_[sno], SIZE_SAVE_NAME).getBytes();
			out.write(data);
			out.flush();
		} catch (Exception e) {
			alert("err writeSPsaves: " + e);
		} finally {
			try {
				out.close();
				out = null;
			} catch (Exception ex) {
				out = null;
			}
		}
	}

	private void writeSPadjusts() {
		// Z[u
		DataOutputStream out = null;
		try {
			out = Connector.openDataOutputStream(
					"scratchpad:///0;pos="
						+ (SIZE_SP_OTHERS + SIZE_SP_KEYS + SIZE_SP_SAVES)
						+ ",length="
						+ SIZE_SP_ADJUST);
			byte[] data = new byte[SIZE_SP_ADJUST];
			for(int i = 0, pos = 0; i < SIZE_SP_ADJUST; i++) {
				data[i] = (byte)((((sdRomadj_[pos++] + 8) & 0xF) << 4) | ((sdRomadj_[pos++] + 8) & 0xF));
			}
			out.write(data);
			out.flush();
		} catch (Exception e) {
			alert("err writeSPsaves: " + e);
		} finally {
			try {
				out.close();
				out = null;
			} catch (Exception ex) {
				out = null;
			}
		}
	}

	private void writeSdromNameSP(final int sdno, final String romnm) {
		// SDRomF30
		DataOutputStream out = null;
		try {
			out = Connector.openDataOutputStream(
					"scratchpad:///0;pos="
						+ (SIZE_SP_SETTING + SIZE_ROM_NAME * sdno)
						+ ",length=" + SIZE_ROM_NAME);
			out.write(formatSpace(romnm, SIZE_ROM_NAME).getBytes());
			out.flush();
		} catch (Exception e) {
			alert("err writeSdromNameSP: " + e);
		} finally {
			try {
				out.close();
				out = null;
			} catch (Exception ex) {
				out = null;
			}
		}
	}

	/////////////////////////////////
	// Utility Method
	/////////////////////////////////

	public void alert(final String s) {
		while (getKeypadState() != 0){
			try {
				Thread.sleep(10L);
			} catch (Exception ex) {}
		}
		Dialog dialog = new Dialog(Dialog.DIALOG_ERROR, "G[I");
		dialog.setText(s);
		dialog.show();
		messageStr = "";
	}

	public void infomsg(final String s) {
		while (getKeypadState() != 0){
			try {
				Thread.sleep(10L);
			} catch (Exception ex) {}
		}
		Dialog dialog = new Dialog(Dialog.DIALOG_INFO , "");
		dialog.setText(s);
		dialog.show();
	}

	private boolean confirm(final String s) {
		while (getKeypadState() != 0){
			try {
				Thread.sleep(10L);
			} catch (Exception ex) {}
		}
		Dialog dialog = new Dialog(Dialog.DIALOG_YESNO, "mF");
		dialog.setText(s);
		boolean ret = (dialog.show() == Dialog.BUTTON_YES);
		return ret;
	}

	private int incNo(int no, final int add, final int max) {
		no += add;
		if (no < 0) {
			no += max;
		}
		no %= max;
		return no;
	}

	private String formatNumber(final int num, final int size) {
		String str = String.valueOf(num);
		while (str.length() < size) {
			str = "0" + str;
		}
		return str;
	}

	private String formatSpace(final String str, final int size) {
		String ret;
		byte[] inbyte = str.getBytes();
		if (inbyte.length > size) {
			ret = new String(inbyte, 0, size);
		} else {
			ret = str;
		}
		while (ret.getBytes().length < size) {
			ret = ret.concat(" ");
		}
		return ret;
	}

	private String[] split(String fromstr, char sptc, int max_size){
		int idx1 = 0 , idx2 = 0, i;
		String[] splt = new String[max_size];
		for(i=0; idx2<fromstr.length() - 1; i++){
			if (i > max_size) break;
			idx2 = fromstr.indexOf(sptc, idx1);
			if(idx2 == -1) idx2 = fromstr.length() - 1;
			splt[i] = fromstr.substring(idx1, idx2);
			idx1 = idx2+1;
		}
		String[] re = new String[i];
		for(int j=0; j<re.length; j++) re[j] = splt[j];
		return re;
	}

	private void keyStr2Vector(final int num) {
		int idx = 0;
		int pre = 0;
		Vector vec = new Vector();
		int ln = 0;
		while ((idx = keyconStr_[num].indexOf(",", pre)) != -1) {
			ln++;
			if (ln > 5) break;
			String key = keyconStr_[num].substring(pre, idx);
			vec.addElement(Integer.valueOf(key));
			pre = idx + 1;
		}
		keyConfig_[num] = new int[vec.size()];
		for (int i = 0; i < vec.size(); i++) {
			keyConfig_[num][i] = ((Integer) vec.elementAt(i)).intValue();
		}
	}
}
